<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Lucky Dice v1.2</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <img style="height: 100px; object-fit: cover; margin: 5px;" class="w-100" src="image/cover.jpg" alt="" id="img-header">
        <div class="row mt-2">
            <div class="col col-sm-6" style="min-height: 100px">
                <h3>Nhập thông tin của bạn</h3>
                <div class="row mt-3">
                    <div class="col col-sm-3">
                        <label for="username">User Name</label>
                    </div>
                    <div class="col col-sm-9">
                        <input type="text" name="username" id="inp-username" class="form-control">
                    </div>
                </div>
                <div class="row mt-2">
                    <div class="col col-sm-3">
                        <label for="firstname">First Name</label>
                    </div>
                    <div class="col col-sm-9">
                        <input type="text" name="firstname" id="inp-firstname" class="form-control">
                    </div>
                </div>
                <div class="row mt-2">
                    <div class="col col-sm-3">
                        <label for="lastname">Last Name</label>
                    </div>
                    <div class="col col-sm-9">
                        <input type="text" name="lastname" id="inp-lastname" class="form-control">
                    </div>
                </div>
            </div>
            <div class="col col-sm-3 text-center" style="max-height: 300px;">
                <img src="image/dice.png" alt="" id="img-dice" style="width: 100%; height: 200px;">
                <button id="btn-newdice" class="btn-success mt-2">New Dice</button>
                <p id="notice-result">...</p>
            </div>
            <div class="col col-sm-3 text-center">
                <img src="image/casino.png" alt="" id="img-prize"
                    style="width: 100%; height: 200px; object-fit: cover;">
                <div id="result-form">
                    <div><b>Voucher:</b>
                        <div style=" display: inline;" id="voucher-result">...</div>
            </div>
            <div><b>Discount:</b>
                <div style="display: inline;" id="discount-result">...</div>
            </div>
        </div>
    </div>
    </div>
    <div class="row mt-5">
        <div class="col col-sm-4">
            <input type="submit" name="dice-history" id="dice-history" class="form-control btn btn-info"
                value="Dice History">
        </div>
        <div class="col col-sm-4">
            <input type="submit" name="dice-history" id="voucher-history" class="form-control btn btn-info"
                value="Voucher History">
        </div>
        <div class="col col-sm-4">
            <input type="submit" name="dice-history" id="present-history" class="form-control btn btn-info"
                value="Present History">
        </div>
    </div>

    <div class="row mt-3">
        <table id="table-data" class="table table-bordered table-striped">
            <thead id="thead" class="text-center">

            </thead>
            <tbody id="tbody" class="text-center">

            </tbody>
        </table>
    </div>

    </div>

    <script>
        //REGION 1:
        const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        var gDataInput = {
            userName: "",
            firstName: "",
            lastName: ""
        };



        //REGION 2:
        $("#btn-newdice").on("click", function () {
            onBtnThrowDice();
        });

        $("#dice-history").on("click", function () {
            onBtnDiceHistory();
        });



        //REGION 3:
        function onBtnThrowDice() {
            // console.log("Nút này đã được ấn");
            gDataInput;
            //B1 THU THAP DU LIEU
            getDataInput(gDataInput);
            //B2: KIEM TRA DU LIEU
            var vIsValidate = isValidate(gDataInput);
            if (vIsValidate) {
                var vJSONDataInPut = JSON.stringify(gDataInput);
                var vXmlHttp = new XMLHttpRequest();
                //B3: THU THAP DU LIEU INPUT GỌI API LAY GIA TRI CỦA DICE
                callApiToGetNewDice(vXmlHttp, vJSONDataInPut);
                vXmlHttp.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        console.log(vXmlHttp.responseText);
                        var vObjDataDice = JSON.parse(vXmlHttp.responseText);
                        handleDataDiceObject(vObjDataDice);
                    }
                }
            }
        }

        function onBtnDiceHistory() {
            console.log("Nút này đã được ấn");
            $("#dice-history").toggleClass("btn btn-warning");
            getDataInput(gDataInput);
            //B2: KIEM TRA DU LIEU
            var vIsValidate = isValidate(gDataInput);
            if (vIsValidate) {
                var vXmlHttp = new XMLHttpRequest();
                //B3: THU THAP DU LIEU INPUT GỌI API LAY GIA TRI CỦA DICE
                callApiToGetDiceHistory(vXmlHttp, gDataInput);
                vXmlHttp.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                         console.log(vXmlHttp.responseText);
                        var vObjDataDiceHistory = JSON.parse(vXmlHttp.responseText);
                        loadDataTable(vObjDataDiceHistory);
                    }
                }
            }
        }



        //REGION 4:
        function getDataInput(paramDataInput) {
            paramDataInput.userName = $("#inp-username").val().trim();
            paramDataInput.firstName = $("#inp-firstname").val().trim();
            paramDataInput.lastName = $("#inp-lastname").val().trim();
        }

        function isValidate(paramDataInput) {
            if (paramDataInput.userName == "") {
                alert("Vui lòng nhập User Name");
                return false;
            }
            if (paramDataInput.firstName == "") {
                alert("Vui lòng nhập First Name");
                return false;
            }
            if (paramDataInput.lastName == "") {
                alert("Vui lòng nhập Last Name");
                return false;
            }
            return true;
        }

        function callApiToGetNewDice(paramXmlHttp, paramJsonDataInput) {
            const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
            paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
            paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
            paramXmlHttp.send(paramJsonDataInput);
        }

        function callApiToGetDiceHistory(paramXmlHttp, paramDataInput) {
            paramXmlHttp.open("GET", gBASE_URL + "/dice-history?username=" + paramDataInput.userName, true);
            paramXmlHttp.send();
        }

        function handleDataDiceObject(paramObjectDataDice) {
            console.log(paramObjectDataDice);
            var vDice = paramObjectDataDice.dice;
            console.log(vDice);
            displayDiceImg(vDice); //HIEN THI ANH SO DIEM XUC XẮC TUONG UNG VOI GIA TRI DICE
            displayNoticeResult(vDice); //HIEN THI CHUC MUNG/RÁT TIEC
            displayVoucherInfo(paramObjectDataDice); //HIEN THI THONG TIN VOUCHER VÀ PRIZE
        }

        //HIEN THI ANH SO DIEM XUC XẮC TUONG UNG VOI GIA TRI DICE
        function displayDiceImg(paramDiceValue) {
            $("#img-dice").prop("src", "image/" + paramDiceValue + ".png")
        }

        //HIEN THI CHUC MUNG/RÁT TIEC
        function displayNoticeResult(paramDiceValue) {
            if (paramDiceValue <= 3) {
                $("#notice-result").html("Tiếc quá bạn thua lượt này rồi <3");
            }
            else {
                $("#notice-result").html("Chúc mừng bạn đã chiến thắng !!");
            }
        }

        //HIEN THI THONG TIN VOUCHER VÀ PRIZe
        function displayVoucherInfo(paramObjectDataDice) {
            if (paramObjectDataDice.voucher == null) {
                $("#img-prize").prop("src", "image/casino.png");
                $("#voucher-result").html("Không có mã giảm giá");
                $("#discount-result").html("0 %");
            }
            else {
                $("#voucher-result").html(paramObjectDataDice.voucher.maVoucher);
                $("#discount-result").html(paramObjectDataDice.voucher.phanTramGiamGia + "%");
                // debugger;
                if (paramObjectDataDice.prize == "Mũ") {
                    $("#img-prize").prop("src", "image/hat.jpg");
                }
                if (paramObjectDataDice.prize == "Áo") {
                    $("#img-prize").prop("src", "image/t-shirt.jpg");
                }
                if (paramObjectDataDice.prize == "Xe máy") {
                    $("#img-prize").prop("src", "image/motobike.jpg");
                }
                if (paramObjectDataDice.prize == "Ô tô") {
                    $("#img-prize").prop("src", "image/car.jpg");
                }
            }
        }

        function loadDataTable(paramDataDiceHistory) {
            console.log(paramDataDiceHistory);
            $("#table-data");
            $("#thead tr").remove();
            $("#tbody tr").remove();
            createTableDiceHistory(paramDataDiceHistory.dices);
        }
        function createTableDiceHistory(paramDiceHistory) {
            // tạo thead
            $("#thead").append(
                '<tr>' +
                // gán giá trị vào col lượt
                '<th >' +
                'Lượt' +
                '</th>' +
                // gán giá trị dices vào col dice 
                '<th >' +
                'Dices' +
                '</th>' +
                '</tr>');
                   // debugger;
            for (var bI = 0; bI < paramDiceHistory.length; bI++){
                var vStt = 1 + bI;
            var vParam = paramDiceHistory[bI];
                $("#tbody").append(
                    '<tr>' +
                        '<td>' + vStt + '</td>' + 
                        '<td>' + vParam + '</td>' +
                    '</tr>'

                    )
            }
        }
    </script>
</body>

</html>